package FriendTamagotchiAgentPackage;

import java.util.*;
import jade.core.*;
import jade.lang.acl.*;
import jade.core.behaviours.*;
import jade.content.onto.*;
import jade.content.lang.*;
import jade.content.lang.sl.*;

import TamagotchiOntology.*;

/**
 * to do: description of the class for the javadoc tool.
 */
public class FriendTamagotchiAgent extends Agent {

  /** Information about ontology */
  private Codec codec = new SLCodec();
  private Ontology ontology = TamaOntology.getInstance();

  /** The message to be sent */
  private ACLMessage msg;

  /** User interface */
  private UserInterface ui;

  /** The Tamagotchi's list of presents */
  Queue<Present> presentList;

  /** Constructor of the agent */
  public FriendTamagotchiAgent() {
    super();
  }

  protected void setup() {
    /** Register the codec for the SL language */
    getContentManager().registerLanguage(codec);

    /** Register the ontology used by this agent */
    getContentManager().registerOntology(ontology);

    // Creating a new User Interface
    //ui = new UserInterface(this);
    //ui.show();

    addBehaviour(new MessageHandler(this));
  }

  protected void takeDown() {
    // to do: add necessary clean-up code
  }

  public ACLMessage getMessage() {
    return msg;
  }

  public UserInterface getUserInterface () {
    return ui;
  }

  public void addPresent(Present present) {
    presentList.add(present);
  }

  public Present getPresent() {
    return presentList.poll();
  }
}
