package MyTamagotchiAgentPackage;

import java.util.*;
import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Sustain_Tamagotchi extends SequentialBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Sustain_Tamagotchi(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void onStart() {
    System.out.println("Sustaining Tamagotchi");
    myTamagotchiAgent.setCurrentBehaviour(this);
    addSubBehaviour(new Set_the_date_and_time(myTamagotchiAgent, userInterface));
    addSubBehaviour(new Set_the_birthday_of_the_owner(myTamagotchiAgent, userInterface));
    addSubBehaviour(new Choose_owner_name(myTamagotchiAgent, userInterface));
    addSubBehaviour(new Tamagotchi_hatches(myTamagotchiAgent, userInterface));
    addSubBehaviour(new Choose_a_name_for_the_Tamagotchi(myTamagotchiAgent, userInterface));
    addSubBehaviour(new Anonymous_behaviour_1(myTamagotchiAgent, userInterface));
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Set_the_date_and_time extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Set_the_date_and_time(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Setting the date and time");
    myTamagotchiAgent.setCurrentBehaviour(this);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Set_the_birthday_of_the_owner extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Set_the_birthday_of_the_owner(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Setting the birthday of the owner");
    myTamagotchiAgent.setCurrentBehaviour(this);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Choose_owner_name extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Choose_owner_name(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Choosing the owner name");
    myTamagotchiAgent.setCurrentBehaviour(this);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Tamagotchi_hatches extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Tamagotchi_hatches(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Tamagotchi is hatching");
    myTamagotchiAgent.setCurrentBehaviour(this);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Choose_a_name_for_the_Tamagotchi extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Choose_a_name_for_the_Tamagotchi(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {

    userInterface.appendMessage("Choosing a name for the Tamagotchi");
    myTamagotchiAgent.setCurrentBehaviour(this);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Anonymous_behaviour_1 extends CyclicBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** UserInterface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Anonymous_behaviour_1 (MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {

    userInterface.setPermission(true);

    myTamagotchiAgent.setCurrentBehaviour(this);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Tamagotchi_is_hungry extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** The message to be sent */
  private ACLMessage msg;

  /** constructor of the behaviour */
  public Tamagotchi_is_hungry(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    //userInterface.appendMessage("Tamagotchi_is_hungry started");

    /** Prepare and send the INFORM message */
    msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(new AID(myAgent.getLocalName(), AID.ISLOCALNAME));
    msg.addReceiver(new AID("ownerAgent", AID.ISLOCALNAME));
    msg.setContent("Your Tamagotchi is hungry");

    myAgent.send(msg);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Tamagotchi_is_sick extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** The message to be sent */
  private ACLMessage msg;

  /** constructor of the behaviour */
  public Tamagotchi_is_sick(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    //userInterface.appendMessage("Tamagotchi_is_sick started");

    /** Prepare and send the INFORM message */
    msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(new AID(myAgent.getLocalName(), AID.ISLOCALNAME));
    msg.addReceiver(new AID("ownerAgent", AID.ISLOCALNAME));
    msg.setContent("Your Tamagotchi is sick");

    myAgent.send(msg);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Tamagotchi_is_unhappy extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** The message to be sent */
  private ACLMessage msg;

  /** constructor of the behaviour */
  public Tamagotchi_is_unhappy(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    //userInterface.appendMessage("Tamagotchi_is_unhappy started");

    /** Prepare and send the INFORM message */
    msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(new AID(myAgent.getLocalName(), AID.ISLOCALNAME));
    msg.addReceiver(new AID("ownerAgent", AID.ISLOCALNAME));
    msg.setContent("Your Tamagotchi is unhappy");

    myAgent.send(msg);
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Feed_the_Tamagotchi extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Feed_the_Tamagotchi(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Feeding the Tamagotchi");
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Cure_the_Tamagotchi extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** constructor of the behaviour */
  public Cure_the_Tamagotchi(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Curing the Tamagotchi");
  }
}

/**
 * to do: description of the behaviour for the javadoc tool.
 */
class Go_to_visit_another_Tamagotchi extends OneShotBehaviour {

  /** MyTamagotchiAgent */
  MyTamagotchiAgent myTamagotchiAgent;

  /** User Interface */
  UserInterface userInterface;

  /** The message to be sent */
  private ACLMessage msg;

  /** constructor of the behaviour */
  public Go_to_visit_another_Tamagotchi(MyTamagotchiAgent agent, UserInterface ui) {
    super(agent);

    myTamagotchiAgent = agent;
    userInterface = ui;
  }

  public void action() {
    userInterface.appendMessage("Visiting another Tamagotchi");

     /** Prepare and send the INFORM message */
    msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(new AID(myAgent.getLocalName(), AID.ISLOCALNAME));
    msg.addReceiver(new AID("friendTamagotchiAgent", AID.ISLOCALNAME));
    msg.setContent("Another Tamagotchi would like to visit");

    myAgent.send(msg);
  }
}
