package OwnerAgentPackage;

import java.util.*;
import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;

/**
 * Class MessageHandler is waiting for incoming messages and will
 * forward the message to an appropriate behaviour
 */
class MessageHandler extends CyclicBehaviour {

    /** Placeholder for the received message */
    private ACLMessage receivedMessage;

    /** My OwnerAgent */
    private OwnerAgent ownerAgent;

    /** User interface */
    private UserInterface userInterface;

    /** constructor of the behaviour */
    public MessageHandler(OwnerAgent agent, UserInterface ui) {
        super(agent);
        ownerAgent = agent;
        userInterface = ui;
    }

    /** actual implementation of the behaviour */
    public void action() {
        // Receive the message
        ACLMessage msg = myAgent.receive();
        if (msg == null) {
          block();
        }
        else {
          if (msg.getPerformative() == ACLMessage.INFORM &&
              msg.getSender().getLocalName().equals(
                  "myTamagotchiAgent")) {

            userInterface.appendMessage(msg.getContent());
          }
        }
      }
    }
