package CDMOntology;

import java.util.*;
import jade.content.Concept;
import java.text.DateFormat;

public class FlightPlan extends Object implements Concept {

    /** Components of a flight plan */
    private Aircraft aircraft;
    private Inbound inbound;
    private Outbound outbound;

    /** Flight statuses */
    private int currentStatus;
    public static final int IS_SCHEDULED = 1;
    public static final int IS_INITIAL = 2;
    public static final int IS_AIRBORNE = 3;
    public static final int IS_FIR = 4;
    public static final int IS_FINAL = 5;
    public static final int IS_LANDED = 6;
    public static final int IS_IN_BLOCK = 7;
    public static final int IS_BOARDING = 8;
    public static final int IS_READY = 9;
    public static final int IS_OFF_BLOCK = 10;
    public static final int IS_DEPARTED = 11;

    /** Return the aircaft description */
    public Aircraft getAircraft() {
        return aircraft;
    }

    /** Return the arrival leg description */
    public Inbound getInbound() {
        return inbound;
    }

    /** Return the departure leg description */
    public Outbound getOutbound() {
        return outbound;
    }

    /** Set the aircaft description */
    public void setAircraft(Aircraft ac) {
         aircraft = ac;
    }

    /** Set the arrival leg description */
    public void setInbound(Inbound ib) {
        inbound = ib;
    }

    /** Set the departure leg description */
    public void setOutbound(Outbound ob) {
        outbound = ob;
    }

    /** Return the current status */
    public int getCurrentStatus() {
        return currentStatus;
    }

    /** Set the current status */
    public void setCurrentStatus(int stat) {
        currentStatus = stat;
    }

    /** Constructor with no parameters */
    public FlightPlan() {
    }

    /** Constructs a new flight plan */
    public FlightPlan(String type, String agent, String opr, String group, String number,
                      Date lTime, Date slTime, String adep, String stand_1,
                      Date tTime, Date stTime, String ades, String stand_2)  throws java.text.ParseException {

        /** Creates the aircraft description */
        aircraft = new Aircraft(type, agent, opr, group, number);
        currentStatus = IS_INITIAL;


        /** Creates the description of the arrival leg */
        inbound = new Inbound(adep, lTime, slTime, stand_1);


        /** Creates the description of the departure leg */
        outbound = new Outbound(ades, tTime, stTime, stand_2);
    }
}
