package CDMOntology;

import java.util.Date;
import jade.content.Concept;

/** Describes the departure leg */
public class Outbound extends Object implements Concept {

    /** Aerodrome of destination */
    String ADES;

    Date takeOffTime;

    Date scheduledTakeOffTime;

    String departureStand;

    /** Constructor with no parameters */
    public Outbound () {
    }

    /** Constructs a new outbound component */
    public Outbound (String ades, Date tTime, Date stTime, String stand) {
        ADES = new String (ades);
        takeOffTime = tTime;
        scheduledTakeOffTime = stTime;
        departureStand = new String (stand);
    }

    /** Return the aerodrome of destination */
    public String getAdes() {
        return ADES;
    }

    /** Return the takeoff time */
    public Date getTakeOffTime() {
        return takeOffTime;
    }

    /** Return the scheduled takeoff time */
    public Date getScheduledTakeOffTime() {
        return scheduledTakeOffTime;
    }

    /** Return the departure stand */
    public String getDepartureStand() {
        return departureStand;
    }

    /** Set the aerodrome of destination */
    public void setAdes(String ades) {
        ADES = new String(ades);
    }

    /** Set the takekoff time */
    public void setTakeOffTime(Date ttime) {
        takeOffTime = ttime;
    }

    /** Set the scheduled takekoff time */
    public void setScheduledTakeOffTime(Date ttime) {
        scheduledTakeOffTime = ttime;
    }

    /** Set the departure stand */
    public void setDepartureStand(String stand) {
        departureStand = new String (stand);
    }
}
